//Copy from the shader
cbuffer TessellationParams : register(b0)
{
  float4x4 viewProj : packoffset(c0);
  float4x4 viewProjLod : packoffset(c4);
  float4 viewOriginLod : packoffset(c8);
  float4 frustumPlanes[4] : packoffset(c9);
  float2 heightMap_world_Material_CellSize : packoffset(c13);
  float2 heightfieldTextureOrigin : packoffset(c13.z);
  float2 rHeightfieldTextureSize : packoffset(c14);
  uint frustumPlanesNum : packoffset(c14.z);
  float proj11 : packoffset(c14.w);
  float tessellationScale : packoffset(c15);
  float tessellationFactorMin : packoffset(c15.y);
  float tessellationFactorMax : packoffset(c15.z);
  float displacementScale : packoffset(c15.w);
  float rDisplacementAttenuationDistance : packoffset(c16);
}

RWBuffer<float4> InvViewMatrixOutputBuffer : register(u0);

float4 inverse_transpose_parallel(matrix m, uint pos)
{
	uint3 idx;
	float4 tmp;

	idx = pos < uint3(1, 2, 3) ? uint3(1, 2, 3) : uint3(0, 1, 2);
	float add = pos % 2 == 0 ? 1.0 : -1.0;

	tmp = m[idx.x].yxxx*(add*m[idx.y].zwyz*m[idx.z].wzwy - add*m[idx.y].wzwy*m[idx.z].zwyz)
	    + m[idx.x].zzyy*(add*m[idx.y].wxwx*m[idx.z].ywxz - add*m[idx.y].ywxz*m[idx.z].wxwx)
	    + m[idx.x].wwwz*(add*m[idx.y].yzxy*m[idx.z].zxyx - add*m[idx.y].zxyx*m[idx.z].yzxy);
	return tmp / determinant(m);
}

[numthreads(4, 1, 1)]
void main(uint3 tid: SV_DispatchThreadID)
{
	// matrix iProj = {projInvMatrix[0], projInvMatrix[1], projInvMatrix[2], projInvMatrix[3]};
	InvViewMatrixOutputBuffer[tid.x] = inverse_transpose_parallel(viewProj, tid.x);
}